<?php

set_include_path(implode(PATH_SEPARATOR, array(
	dirname(__FILE__) . '/system/classes/dbtables',
	dirname(__FILE__) . '/system/classes/mappers',
	dirname(__FILE__) . '/system/classes/models',
    get_include_path()
)));

class Youtubefeed extends Tools_Plugins_Abstract {

	private $_pageUrl = null;
    
    const ACT_INDEX     = 'index';
	const ACT_GETTHUMBS = 'getthumbs';
	const ACT_GETPLAYER = 'getplayer';
	const ACT_SETTINGS  = 'showsettings';
	const ACT_APPLY     = 'applysettings';
    const MODE_PLAYER   = 'player';
    const MODE_THUMBS   = 'thumbs';
    const MODE_PLAYLIST = 'playlist';
    const URL_PLAYLIST_FEED = 'http://gdata.youtube.com/feeds/api/playlists/';
    
    
    
	public function  __construct($options, $seotoasterData) {
		parent::__construct($options, $seotoasterData);
        $this->_view->setScriptPath(dirname(__FILE__) . '/views/');
                        
    }
    public function run($requestedParams = array()) {
        $this->_requestedParams = $requestedParams;
        $dispatchersResult      = parent::run($requestedParams);
        $this->_view->AdminLogged = Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_CONTENT);
        $this->_view->pageId = $this->_seotoasterData['id'];

        $this->_view->random = (end($this->_options) == 'random') ? '1' : '0';
        if(isset($this->_options[0])){
            $this->_view->mode    = $this->_options[0];
            if(isset($this->_options[1])){
                $this->_view->request = $this->_options[1];
            }
            $mapper = YoutubefeedMapper::getInstance();
            $сonfig = $mapper->selectProperties($this->_seotoasterData['id']);
            if(!empty($сonfig)){
                $this->_view->usewithVideolink = $сonfig[0]->getUseVideolink();
            }
            else{
                $this->_view->usewithVideolink = '0';
            }
            $this->_view->translator = $this->_translator;
            return $this->_view->render('utubvi.phtml');
        }


    }
    public function _getVideoThumbs() {
        $start = $this->_request->getParam('start');
        $pageId = $this->_request->getParam('pageId');
        $random = $this->_request->getParam('random');
        $mapper = YoutubefeedMapper::getInstance();
        $сonfig = $mapper->selectProperties($pageId);
        $youTube    = new Zend_Gdata_YouTube();
        $videoQuery = $youTube->newVideoQuery();
        $requestParam = trim($this->_request->getParam('requestStr'));
        $requestType = $this->_request->getParam('requestType');
        $videoQuery->videoQuery = $requestParam;
        $videoQuery->startIndex = ($start) ? $start : 1;
        if(!empty($сonfig)){
            $maxResults = $сonfig[0]->getThumbPerPage();
            $realMaxResult = $maxResults;
            if($random == '1'){
                $maxResults = 50;
            }
            $videoQuery->maxResults = $maxResults;
            $this->_view->thumbsWidth = $сonfig[0]->getThumpWidth();
            $this->_view->thumbsHeight = $сonfig[0]->getThumbHeight();
        }
        else{
            $realMaxResult = 5;
            $maxResults = 5;
            if($random == '1'){
                $maxResults = 50;
            }
            $videoQuery->maxResults = $maxResults;
            $this->_view->thumbsWidth = 180;
            $this->_view->thumbsHeight = 200;
        }
        $videoQuery->orderBy = 'relevance';
        if (self::MODE_THUMBS == $requestType) {
            $videoFeed = $youTube->getVideoFeed($videoQuery);
        }
        elseif (self::MODE_PLAYLIST == $requestType) {
            $startIndex = ($start) ? $start : 1;
            try{
                $videoFeed = $youTube->getPlaylistVideoFeed(self::URL_PLAYLIST_FEED.$requestParam.'?v=2&max-results='.$maxResults.'&start-index='.$startIndex);
            }catch(Exception $e){

            }
        }
        $videoThumbs = array();
        foreach ($videoFeed as $entry) {
            $videoThumbs[] = array(
                'vId' => $entry->getVideoId(),
                'url' => $entry->mediaGroup->thumbnail[0]->url,
                'title' => substr($entry->mediaGroup->title, 0, 15) . '...',
                'titlelong' => $entry->mediaGroup->title
            );
        }
        if($random == '1'){
            shuffle($videoThumbs);
            if(count($videoThumbs) > $realMaxResult){
                $videoThumbs = array_slice($videoThumbs, 0, $realMaxResult);
            }
        }
        $this->_view->thumbs = $videoThumbs;
        $next = ($start) ? $start +  $realMaxResult : $realMaxResult + 1;
        $this->_view->next = $next;
        $prev = $next - ($realMaxResult *2);
        $this->_view->prev = ($prev <= 1) ? 1 : $prev;

        return $this->_view->render('thumbs.phtml');

    }
    public function getVideoThumbsAction(){
         echo json_encode(array('content' => $this->_getVideoThumbs()));
    }
    public function checkVideolinkAction() {
        $useVideolink = $this->_request->getParam('usewithVideolink');
        $pluginMapper = Application_Model_Mappers_PluginMapper::getInstance();
        $exsistVideolink = $pluginMapper->findByName('videolink');
        if($exsistVideolink == null){
           echo json_encode(array('pluginExcist' => 0, 'checkbox' => $useVideolink));
        }
        else{
           echo json_encode(array('pluginExcist' => 1, 'checkbox' => $useVideolink));
        }
    }
    public function getPlayerAction() {
        echo json_encode(array('content' => $this->_getPlayer()));
    }
    public function _getPlayer() {
         if($this->_request->isPost()) {
			$videoId = $this->_request->getParam('videoId');
            $pageId = $this->_request->getParam('pageId');
			if($videoId) {
				$youTube = new Zend_Gdata_YouTube();
                $mapper = YoutubefeedMapper::getInstance();
                $model  = new YoutubefeedModel();
                $сonfig = $mapper->selectProperties($pageId);
                if(!empty($сonfig)){
                    $this->_view->playerWidth = $сonfig[0]->getPlayerWidth();
                    $this->_view->playerHeight = $сonfig[0]->getPlayerHeight();
                }
                else{
                    $this->_view->playerWidth = 280;
                    $this->_view->playerHeight = 200;
                }
				$entry = $youTube->getVideoEntry($videoId);
                $result = $this->_getVideoMetaData($entry);
                $url = $result['url'];
                $url = preg_replace("/\/v\//", '/embed/', $url);
                $this->_view->url = $url;
                $this->_view->meta = $result;
				//$this->_view->meta       = $this->_getVideoMetaData($entry);
				return $this->_view->render('player.phtml');
			}
		}
	}
    public function _getVideoMetaData($entry) {
		return array(
			'title'       => $entry->mediaGroup->title,
			'url'         => $this->_getFlashUrl($entry),
			'description' => $entry->mediaGroup->description,
			'authorName'  => $entry->author[0]->name,
			'authorUrl'   => 'http://www.youtube.com/profile?user=' . $entry->author[0]->name,
			'tags'        => $entry->mediaGroup->keywords,
			'duration'    => $entry->mediaGroup->duration->seconds,
			'watchPage'   => $entry->mediaGroup->player[0]->url,
			'views'       => $entry->statistics->viewCount,
			'rating'      => $entry->rating->average,
			'numRaters'   => $entry->rating->numRaters
		);
	}
    public function _getFlashUrl($entry) {
		foreach ($entry->mediaGroup->content as $content) {
			if ($content->type === 'application/x-shockwave-flash') {
				return $content->url;
			}
		}
		return null;
	}
    public function showSettingsAction(){
        if(Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_CONTENT)){
            $mapper = YoutubefeedMapper::getInstance();
            $pageId = $this->_request->getParam('pageId');
            $model  = new YoutubefeedModel();
            $сonfig = $mapper->selectProperties($pageId);
            $this->_view->pageId = $pageId;
            $this->_view->translator = $this->_translator;
            if(!empty($сonfig)){
                $this->_view->thumbsWidth = $сonfig[0]->getThumpWidth();
                $this->_view->thumbsHeight = $сonfig[0]->getThumbHeight();
                $this->_view->thumbsPerPage = $сonfig[0]->getThumbPerPage();
                $this->_view->usewithVideolink = $сonfig[0]->getUseVideolink();
                $this->_view->playerWidth = $сonfig[0]->getPlayerWidth();
                $this->_view->playerHeight = $сonfig[0]->getPlayerHeight();
            }
            else{
                $сonfig = $mapper->selectProperties('0');
                $this->_view->thumbsWidth = $сonfig[0]->getThumpWidth();
                $this->_view->thumbsHeight = $сonfig[0]->getThumbHeight();
                $this->_view->thumbsPerPage = $сonfig[0]->getThumbPerPage();
                $this->_view->usewithVideolink = $сonfig[0]->getUseVideolink();
                $this->_view->playerWidth = $сonfig[0]->getPlayerWidth();
                $this->_view->playerHeight = $сonfig[0]->getPlayerHeight();
            }
            echo $this->_view->render('settings.phtml');
        }
    }
    public function applySettingsAction(){
        if(Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_CONTENT)){
            $thumbsWidth = trim($this->_request->getParam('thumbsWidth'));
            $thumbsHeight = trim($this->_request->getParam('thumbsHeight'));
            $thumbsPerPage = trim($this->_request->getParam('thumbsPerPage'));
            $useVideolink = trim($this->_request->getParam('usewithVideolink'));
            $playerWidth = trim($this->_request->getParam('playerWidth'));
            $playerHeight = trim($this->_request->getParam('playerHeight'));
            $pageId = $this->_request->getParam('pageId');
            $mapper = YoutubefeedMapper::getInstance();
            $model  = new YoutubefeedModel();
            $model->setThumpWidth($thumbsWidth);
            $model->setThumbHeight($thumbsHeight);
            $model->setThumbPerPage($thumbsPerPage);
            $model->setPlayerWidth($playerWidth);
            $model->setPlayerHeight($playerHeight);
            $model->setUseVideolink($useVideolink);
            $model->setPageId($pageId);
            $mapper->save($model);
        }
        echo ('true');
    }
    protected function _makeOptionName() {
		
	}
          
}

